#!/usr/local/bin/perl
##############################################################################
# If you encounter problems while trying to configure this script, help      #
# is available.  In order to get your problem solved:                        #
#       1) Read this file thoroughly                                         #
#       2) Consult the THANKS-CGI Frequently Asked Questions:                #
#               http://www.thanks-cgi.com/faq/                               #
#       3) If you are still having difficulty installing this script, send   #
#          e-mail to: support@thanks-cgi.com                                 #
#          Include any error messages you are receiving and as much detail   #
#          as you can so we can spot your problem.                           #
#                                                                            #
# Hopefully we will be able to help you solve your problems.  Thank you.     #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1998 THANKS-CGI All Rights Reserved.                             #
#  Not for re-sell or re-distribution.                                       #
##############################################################################
# Setup Begin
$cgiurl         = "http://www.yourdomain.com/cgi-bin/guestbook2/guestbook.cgi"; # THE URL OF CGI SCRIPT.
$filehead       = "/usr/yourdomain/guestbook2/"; # THE REAL PATH OF "*.htm", "*.txt" FILES. (YOU MAY CONTACT YOUR ISP FOR THIS PATH)
$guestbookfile  = "guestbook.txt"; # DATABASE OF MESSAGES
$mainpagefile   = "index.html";    # MAIN PAGE OF YOUR GUESTBOOK
$succpagefile   = "succ.htm";      # THE PAGE AFTER LEAVING MESSAGE
$errorpagefile  = "error.htm";     # THE PAGE TO SHOW ERROR MESSAGE
$managepagefile = "manage.htm";    # THE PAGE OF CONTROL PANEL

$allow_html     = 0;   # 1=ALLOWS VISTORS TO USE HTML. 2=DISABLE IT.
$perpage        = 20;  # MAXIUM MESSAGES FOR EACH PAGE
$manageperpage  = 100; # MAXIUM MESSAGES OF CONTROL MODE
$time_miss      = +12; # TIMER

$manage{"super"}="123456"; # ID & PASSWORD FOR WEBMASTER

$masteremail = "yourname\@yourdomain.com"; # YOUR E-MAIL ADDRESS
$mailprg     = "/bin/sendmail -t";         # THE PATH OF YOUR SERVER'S E-MAIL SYSTEM
$fromemail   = "yourname\@yourdomain.com"; # YOUR E-MAIL ADDRESS
$sendtomaster= 0;                          # 1=ENABLE 0=DISABLE (FONCTION OF AUTO NOTICE)

# END
#############
#$|=1;

&get_form;
&set_var;

$manage=0;
if (($manageid ne "") && ($managepassword ne "")) {
   if ($manage{$manageid} eq $managepassword) {
      $manageinfo="&manageid=$manageid&managepassword=$managepassword";
      $manage=1;
      $perpage=$manageperpage;
   }
}

print "Content-type: text/html\n";
print "Set-Cookie: cookieusername=$username; expires=30-Dec-99 GMT\n" if (($username ne "") && ($cookieusername ne $username));
print "Set-Cookie: cookieuseremail=$useremail; expires=30-Dec-99 GMT\n" if (($useremail ne "") && ($cookieuseremail ne $useremail));
print "Set-Cookie: cookieuserurl=$userurl; expires=30-Dec-99 GMT\n" if (($userurl ne "") && ($cookieuserurl ne $userurl));
print "\n";

$cookieusername=$username if (($username ne "") && ($cookieusername ne $username));
$cookieuseremail=$useremail if (($useremail ne "") && ($cookieuseremail ne $useremail));
$cookieuserurl=$userurl if (($userurl ne "") && ($cookieuserurl ne $userurl));

if ($job eq "add") {
   &guestbook_add;
   exit 0;
}
elsif ($job eq "manage") {
   &guestbook_manage;
   exit 0;
}
elsif (($job eq "erase") && ($manage==1)) {
   &guestbook_erase;
   exit 0;
}

@mainpagefile=&readtxtfile("$filehead$mainpagefile");
foreach (@mainpagefile) { 
   if ($_ =~ /<!--listhere-->/) {
      if ($page eq "") {$page=1;}

      @guestbook=&readtxtfile("$filehead$guestbookfile",1);
      @guestbook=sort @guestbook;
      if ($searchword ne "") {
         @temp=();
         foreach (@guestbook) {
            if ($_ =~ /$searchword/i) {
               push(@temp,"$_");
            }
         }
         @guestbook=@temp;
      } 
      $totalguestbook=$#guestbook+1;
      splice(@guestbook,0,$#guestbook-$page*$perpage+1);
      splice(@guestbook,$#guestbook-($page-1)*$perpage+1,($page-1)*$perpage);

      print "<form method=post action=$cgiurl?job=erase&searchword=$searchword&page=$page$manageinfo>\n" if ($manage==1);
      if ($#guestbook>=0) {
         for ($i=$#guestbook;$i>=0;$i--) {
             ($mark,$chkdaten,$chktimen,$chkusername,$chkuserip,$chkuseremail,$chkuserurl,$chkcomments,$markend,$last)=split(//,$guestbook[$i]);
             $guestbook[$i]=~ s/$searchword/<font color=ff0000>$searchword<\/font>/gi if ($searchword ne "");     
             ($mark,$chkdaten1,$chktimen1,$chkusername1,$chkuserip1,$chkuseremail1,$chkuserurl1,$chkcomments1,$markend,$last)=split(//,$guestbook[$i]);
             if (($mark eq "guestbook") && ($markend eq "end")) {
                $temp1="";
                $temp1="<blink><i>Today</i></blink>" if ($chkdaten eq $daten);
                $temp2=""; 
                $temp2="<input type=checkbox name='guestbookmark' value='$chkdaten$chktimen'>" if ($manage==1);
                print "$temp1\n"; 
                print "<table border=0>\n";
                print "<tr><td>$temp2<font size=+1><b>$chkusername1</b></font><font size=-1><i>($chkuserip1) at $chkdaten1($chktimen1)..</i></font></td></tr>\n";
                print "<tr><td>\n";
                if (($chkuseremail ne "") || ($chkuserurl ne "")) {
                   print "Email: <a href=mailto:$chkuseremail>$chkuseremail1</a><br>\n" if ($chkuseremail ne "");
                   print "HomePage: <a href=$chkuserurl target='others'>$chkuserurl1</a><br>\n" if ($chkuserurl ne "");
                }
                print "$chkcomments1\n";
                print "</td></tr></table>\n<hr size=1>\n"; 
             }
         }
      }
      print "<input type=submit value='DELETE'>\n</form>\n" if ($manage==1);
   }
   elsif ($_ =~ /<!--otherpagehere-->/) {
      $i=1;
      $j=$totalguestbook;
      while ($j>0) {
         print " ";
         print "<a href=$cgiurl?page=$i&searchword=$searchword$manageinfo>" if ($page != $i); 
         print "$i"; 
         print "</a>" if ($page != $i);
         $j=$j-$perpage; 
         $i++;
      }
   }
   else {
      $_ =~ s/\$cgiurl/$cgiurl/g;
      $_ =~ s/\$cookieusername/$cookieusername/g;
      $_ =~ s/\$cookieuseremail/$cookieuseremail/g;
      $_ =~ s/\$cookieuserurl/$cookieuserurl/g;
      $_ =~ s/\$manageinfo/$manageinfo/g;
      $_ =~ s/\$searchword/$searchword/g;
      print "$_";
   }
}
exit 0;
##########
sub guestbook_add {
&checkempty($username,"Your name cannot be blank!");
&checkempty($comments,"Your message cannot be blank!");
     
open(GUESTBOOK,">>$filehead$guestbookfile");
print GUESTBOOK "guestbook$daten$timen$username$userip$useremail$userurl$commentsend\n";
close(GUESTBOOK);

if ($sendtomaster==1) {
   open (OUTMAIL,"| $mailprg") || die "Mail system error";
   print OUTMAIL "To: $masteremail\n";
   print OUTMAIL "Subject: Guest Notice...\n";
   print OUTMAIL "From: $fromemail\n";
   print OUTMAIL "======================================\n";
   print OUTMAIL "NAME: $username($userip) at $daten($timen)\n";
   print OUTMAIL "EMAIL: $useremail\n" if ($useremail ne "");
   print OUTMAIL "HOMEPAGE: $userurl\n" if ($userurl ne "");
   $comments =~ s/<br>/\n/g;
   print OUTMAIL "$comments\n";
   print OUTMAIL "======================================\n";
   print OUTMAIL "\n\n";
   close(OUTMAIL);
}
&guestbook_succ("Thank you! Your message has been successfully posted!!");
}
##########
sub guestbook_manage {
@managepagefile=&readtxtfile("$filehead$managepagefile");
foreach (@managepagefile) {
   $_ =~ s/\$cgiurl/$cgiurl/g;
   print "$_";
}
}
##########
sub guestbook_erase {
if ($guestbookmark ne "") {
   @guestbook=&readtxtfile("$filehead$guestbookfile",1);
   @guestbook=sort @guestbook;

   open(GUESTBOOK,">$filehead$guestbookfile");
   foreach (@guestbook) {
      ($mark,$chkdaten,$chktimen,$chkusername,$chkuserip,$chkuseremail,$chkuserurl,$chkcomments,$markend,$last)=split(//,$_);
      if (($mark eq "guestbook") && ($markend eq "end")) {
         if (!($guestbookmark =~ /$chkdaten$chktimen/)) {
            print GUESTBOOK "$_"; 
         }
      }
   }
   close(GUESTBOOK);
}
&guestbook_succ("DELETED!");
}
##########
sub guestbook_succ {
@succpagefile=&readtxtfile("$filehead$succpagefile");
foreach (@succpagefile) {
   $_ =~ s/\$cgiurl/$cgiurl/g;
   $_ =~ s/\$manageinfo/$manageinfo/g;
   $_ =~ s/\$searchword/$searchword/g;
   $_ =~ s/\$page/$page/g;
   $_ =~ s/\$succmessage/$_[0]/g;
   print "$_";
}
}
##########
sub set_var {
$job            =&get_var('job'            ,'\n|');
$username       =&get_var('username'       ,'\n|"|<|>|\&|;|\?|');
$useremail      =&get_var('useremail'      ,'\n|| ');
$userurl        =&get_var('userurl'        ,'\n|| ');
$cookieusername =&get_var('cookieusername' ,'\n|"|<|>|\&|;|\?|');
$cookieuseremail=&get_var('cookieuseremail','\n|| ');
$cookieuserurl  =&get_var('cookieuserurl'  ,'\n|| ');
$comments       =&get_var('comments'       ,'');
$searchword     =&get_var('searchword'     ,'\n|');
$page           =&get_var('page'           ,'\n|');
$guestbookmark  =&get_var('guestbookmark'  ,'\n');
$manageid       =&get_var('manageid'       ,'\n|"|<|>|\&|;| |\?|');
$managepassword =&get_var('managepassword' ,'\n|"|<|>|\&|;| |\?|');

$useremail="" if (!($useremail =~ /.*\@.*\..*/));
$userurl  ="" if (!($userurl   =~ /.*\:.*\..*/ ));
$comments =~ s/\n/<br>/g;

$cookieuseremail=""        if (!($cookieuseremail =~ /.*\@.*\..*/));
$cookieuserurl  ="http://" if (!($cookieuserurl   =~ /.*\:.*\..*/ ));

$userip=$ENV{'REMOTE_ADDR'};

($secn,$minn,$hourn,$dayn,$monn,$yearn,$weekn,$yeardayn,$isdst) = localtime(time+(3600*$time_miss));
$monn=$monn+1;
if ($monn<10)  {$monn="0$monn";}
if ($dayn<10)  {$dayn="0$dayn";}
if ($hourn<10) {$hourn="0$hourn";}
if ($minn<10)  {$minn="0$minn";}
if ($secn<10)  {$secn="0$secn";}
$daten="$yearn/$monn/$dayn";
$timen="$hourn\:$minn\:$secn";
}


############
sub get_form {
@querys = split(/&/, $ENV{'QUERY_STRING'});
foreach (@querys) {
  ($name,$value) = split(/=/, $_);
  $value = &decode($value);
  $value = &filterhtml($value);
  &setvaluetoform($name, $value); 
}

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach (@pairs) {
  ($name, $value) = split(/=/, $_);
  $value = &decode($value);
  $value = &filterhtml($value);
  &setvaluetoform($name, $value); 
}

@cookies = split(/; /, $ENV{HTTP_COOKIE});
foreach $cookies (@cookies) {
   ($name, $value) = split(/=/, $cookies);
   $value = &decode($value);
   $value = &filterhtml($value);
   &setvaluetoform($name, $value); 
}
}
##########
sub decode {
local($return)=$_[0];
$return =~ tr/+/ /;
$return =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
return $return;
}
##########
sub filterhtml {
local($return)=$_[0];
$return =~ s/<!--(.|\n)*-->//g;
if ($allow_html != 1) {
   $return =~ s/<([^>]|\n)*>//g;
   $return =~ s/<//g;
}
return $return;
}
##########
sub setvaluetoform {
if ($FORM{$_[0]}) {
   $FORM{$_[0]}="$FORM{$_[0]}$_[1]";
}
else {
   $FORM{$_[0]}=$_[1];
}
}
#########
sub get_var {
local($return)="";
$return="$FORM{$_[0]}" if ($FORM{$_[0]});
$return=~ s/$_[1]//g;
return $return;
}
#########
sub readtxtfile {
open(READTXTFILE,"$_[0]");
@readtxtfile=<READTXTFILE>;
close(READTXTFILE);
return @readtxtfile;
}
#############
sub checkempty {
local($chkval)=$_[0];
$chkval =~ s/ |<br>|\n//g;
&error($_[1]) if ($chkval eq "");
}
##########
sub error {
@errorpagefile=&readtxtfile("$filehead$errorpagefile");
foreach (@errorpagefile) {
   $_ =~ s/\$errormessage/$_[0]/g;
   print "$_";
}
exit 0;
}
